<?php namespace Core\Kernel;

class HmsBuilder
{
    public $firstGET = null;
/*
 * Checking input parameters $ _GET to load the necessary kernel configuration
 */
    public function __construct()
    {
        if (count($_GET)) {
            $g_index = '';
            foreach ($_GET as $param => $get) {
                $g_index[] = $param;
            }
            $this->firstGET = $g_index[0];
        }
    }
/*
 * [RU]Cборка ядра исходя из конфигурации полученной ранее,
 * зависит от первого параметра $_GET
 * Через переменную $param можно передавать дополнительные
 * инструкции инициализации ядра(Выключать или включать модули)
 * По умолчанию ядро загрузится с заранее
 * предопределенными модулями.
 *
 * [EN]Building the kernel based on the configuration
 * of the earlier, depends on the first parameter $_GET
 * After $param variable can pass additional
 * instructions kernel initialization (turns off or modules)
 * By default, the kernel has been loaded with a
 * pre-specified modules.
 */
    public function compileKernel($param = null)
    {
        return new \Core\Kernel\HmsCore($param);
    }
}
