<?php namespace Core\Kernel;

/* Created: HM:Script
*  Website: http://hmscript.net
*     User: zpVs
*     Date: 10.05.13
*     Time: 19:29
*  Version: 1.5.0
*   Script: hStation CMS
*/
class HmsChannel
{
    public $id;
    public $name;
    public $description;
    public $logo;
    public $thumbnail;
    public $access;
    public $iframe;

    public function __construct($id, $name, $description = '', $logo = '', $thumbnail = '', $access = '', $iframe = '')
    {
        $this->id = $id;
        $this->name = $name;
        $this->description = $description;
        $this->logo = $logo;
        $this->thumbnail = $thumbnail;
        $this->access = $access;
        $this->iframe = $iframe;
    }
    public function __channeldata($param)
    {
        global $core;

        return $core::$dbs->getChannelInfo($param, $this->id);
    }
    public function getId()
    {
        return $this->id;
    }
    public function getName()
    {
        return $this->name;
    }
    public function getDescription()
    {
        return $this->description;
    }
    public function getIframe()
    {
        if ($this->iframe == 1) {
            return true;
        } else {
            return false;
        }
    }
    public function getLogo()
    {
        global $core;
        $logo = $core::$dbs->d_cfg['site_url'].'/content/uploads/images/c_logos/'.$this->logo;

        return $logo;
    }
    public function getThumbnail()
    {
        global $core;
        $thumbnail = $core::$dbs->d_cfg['site_url'].'/content/uploads/images/c_thumbnail/'.$this->thumbnail;

        return $thumbnail;
    }
    public function getAccess()
    {
        return $this->access;
    }
    public function getLang()
    {
        return $this->__channeldata('lang');
    }
    public function getState()
    {
        global $core;
        $state = $core::$dbs->getChannelState($this->id);
        if ($state == 1) {
            return true;
        } else {
            return false;
        }
    }
    public function getFeaturedState()
    {
        global $core;
        $state = $core::$dbs->getFeaturedState($this->id);
        if ($state == 1) {
            return true;
        } else {
            return false;
        }
    }
    public function getIframeState()
    {
        if ($this->iframe == 1) {
            return true;
        } else {
            return false;
        }
    }
    public function getKeywords()
    {
        global $core;
        $key_array = explode(",", $core::$dbs->getChannelTag($this->id));
        $keywords = '';
        if (!empty($key_array[0])) {
            shuffle($key_array);
            for ($x=0; $x<21; $x++) {
                $key_array[$x] = preg_replace('/\s\s+/', ' ', $key_array[$x]);
                if ($x == 20) {
                    $keywords .= $key_array[$x];
                } else {
                    $keywords .= $key_array[$x].',';
                }
            }
        }

        return $keywords;
    }
    public function getViews()
    {
        return $this->__channeldata('views');
    }
    public function getLikes()
    {
        return $this->__channeldata('likes');
    }
    public function getCategory($index)
    {
        global $core;
        $cat = $core::$dbs->getCategory($this->id);

        return $cat[$index];
    }
    public function getUrl()
    {
        global $core;
        if ($core::$dbs->d_cfg['chpu'] == '1') {
            $stream = $core::$dbs->d_cfg['site_url'].'/onlinetv/'.$this->id.'/';
        } else {
            $stream = $core::$dbs->d_cfg['site_url'].'/?onlinetv&stream='.$this->id;
        }

        return $stream;
    }
    public function getHrefAlt()
    {
        $info = __cutStr($this->description, 135);

        return $info;
    }
    public function getHrefTitle()
    {
        $info = 'Смотреть канал &laquo;'.$this->name.'&raquo; онлайн';

        return $info;
    }
    public function getTags()
    {
        global $core;
        $tags = explode(",", $core::$dbs->getChannelTag($this->id));
        shuffle($tags);
        $tags_link = '';
        foreach ($tags as $tag) {
            $tags_link .= '<a href="#" title="'.$tag.'">'.$tag.'</a>, ';
        }

        return $tags_link;
    }
    public function getStreamLink($type = '', $crypt = false)
    {
        global $core;
        if (isset($core::$engine->a_get['web'])) {
            $type = '';
        }
        switch ($type) {
            case 'playlist':
                $return_stream = $this->id.':'.$core::$user->getId();
                break;
            default:
                $return_stream = $this->id.':-1';
        }
        ($core::$dbs->d_cfg['chpu'] == '1')? $chpu_link = 'view/':$chpu_link = '?view=';

        if ($crypt) {
              $t = new HmsCrypt;
              $stream_link = urlencode($t::encrypt($return_stream));
        } else {
              $stream_link = urlencode($return_stream);
        }

        return $core::$dbs->d_cfg['site_url'].'/'.$chpu_link.$stream_link;
    }
    public function getStream()
    {
        global $core;
        $stream = $core::$dbs->getStream($this->id);

        return $stream;
    }
    public function getTorrentStream($crypt = false)
    {
        /*
         * http://sat.hms.pp.ua/?stream=8:33:1:0:755P:E1L:338621:0:1:0:0:
         */
        global $core;
        if ($crypt) {
            $stream = $core::$dbs->getTorrentStream($this->id);
        } else {
            $stream = $core::$dbs->getTorrentStream($this->id);
        }

        return $stream;
    }

    public function setView()
    {
        global $core;

        return $core::$dbs->setChannelView($this->id);
    }
    public function setLikes()
    {
        global $core;

        return $core::$dbs->setChannelLikes($this->id);
    }
}
