<?php namespace Core\Kernel;

/* Created: HM:Script
*  Website: http://hmscript.net
*     User: ZpVs
*     Date: 23.04.13
*     Time: 16:05
*  Version: 1.0.0
*   Script: hStation CMS
*/
class HmsEngine
{
    protected $load = true;        /* Разрешена ли загрузка инструментов ядра*/
    public $handler = null;        /* Базовый обработчик Инструментов ядра*/
    public $query_post = false;    /* Поступают ли POST запросы*/
    public $a_post = array();      /* Масив поступающих POST запросов*/
    public $a_post_index = array();
    public $query_get = false;     /* Поступают ли GET запросы */
    public $a_get = array();       /* Масив поступающих GET запросов */
    public $a_get_index = array();

    public function __construct()
    {
        if ($this->load) {
            $this->initQueryType();
            $this->initQuery();
        }
    }
    /**
     * Инициализация поступающих POST и GET запросов
     * и определение типа запроса.
     */
    protected function initQueryType()
    {
        if (count($_GET) > 0) {
            $this->query_get = true;
        }
        if (count($_POST) > 0) {
            $this->query_post = true;
        }
    }
    /**
     * Перенос поступивших POST и GET запросов во
     * внутрений масив с присвоением индексов.
     */
    protected function initQuery()
    {
        if (count($_GET) > 0) {
            foreach ($_GET as $keyGet => $valueGet) {
                $this->a_get[mf_guard($keyGet)] = mf_guard($valueGet);
                $this->a_get_index[] = $keyGet;
            }
        }
        if (count($_POST) > 0) {
            foreach ($_POST as $keyPost => $valuePost) {
                $this->a_post[mf_guard($keyPost)] = $valuePost;
                $this->a_postindex[] = $keyPost;
            }
        }
    }

    /**
     * Инициализация необходимых инструментов для дальнейшей
     * обработки данных ядра согластно поступающих запросов
     * если не инициализирован базовый обработчик то
     * производим поиск обработчика по поступающему запросу
     * при  нахождении обрабочика инициализируем его.
     */
    public function initEngineHandler()
    {
        global $core;
        $core::$template->init = true;
        $core::$template->extendConstruct();
        include $core::ENGPATH.'global.inc.php';
        if ($this->handler == null) {
            if ($this->query_get) {
                $dir = opendir($core::ENGPATH);
                while (false !== ($file = readdir($dir))) {
                    if ($file != "." && $file != ".."
                        && $file != "Thumbs.db"
                        && $file != ".DS_Store"
                        && $file != "global.inc.php") {
                        if ($file == $this->a_get_index[0].'.inc.php') {
                                include $core::ENGPATH.''.$this->a_get_index[0].'.inc.php';
                        } else {
                            if ($core::$user->getRole() > 1 && $this->a_get_index[0] == 'cp') {
                                include_once (CONTROL.'cp.inc.php');
                            }
                        }
                    }
                }
                closedir($dir);
            }
        } else {
            include $core::ENGPATH.''.$this->handler;
        }

    }
}
