<?php namespace Core\Kernel;

/* Created: HM:Script
*  Website: http://hmscript.net
*     User: ZpVs
*     Date: 23.04.13
*     Time: 16:05
*  Version: 1.0.0
*   Script: hStation CMS := hMailer system
*/

class HmsMailer
{
    public $postWhere = null;
    public $postSubject = null;
    public $postTemplate = null;
    private $defaultServer = null;
    private $defaultPort = null;
    private $defaultLogin = null;
    private $defaultPass = null;

    public function __construct()
    {
        $dbs = new  \Core\Kernel\HmsDbs();
        if ($this->defaultServer == null) {
            $this->defaultServer = $dbs->d_cfg['smtp_server'];
        }
        if ($this->defaultLogin == null) {
            $this->defaultLogin = $dbs->d_cfg['smtp_user'];
        }
        if ($this->defaultPort == null) {
            $this->defaultPort = $dbs->d_cfg['smtp_port'];
        }
        if ($this->defaultPass == null) {
            $this->defaultPass = $dbs->d_cfg['smtp_pass'];
        }
    }
    public function mailerServerCode($SMTP)
    {
        $data="";
        while ($str = fgets($SMTP, 515)) {
            $data .= $str;
            if (substr($str, 3, 1) == " ") {
                break;
            }
        }

        return $data;
    }
    public function sendMailHeader()
    {
        $hdata ="To: ".$this->postWhere."\r\n";
        $hdata.="From: ".$this->defaultLogin."\r\n";
        $hdata.="Reply-To:".$this->defaultLogin."\r\n";
        $hdata.="Subject: ".$this->postSubject." \r\n";
        $hdata.="MIME-Version: 1.0\r\n";
        $hdata.="Content-Type: text/html; charset=utf-8\r\n";
        $hdata.="Content-Transfer-Encoding: 8bit\r\n";

        return $hdata;
    }
    public function sendMailError($eSMTP)
    {
        fclose($eSMTP);
    }
    public function sendMail()
    {
        $SMTP = fsockopen($this->defaultServer, $this->defaultPort, $eNumber, $eString, 10);
        if (!$SMTP) {
            $this->sendMailError($SMTP);
        }
        $code = substr($this->mailerServerCode($SMTP), 0, 3);
        fputs($SMTP, "EHLO ".$this->defaultServer."\r\n");
        if (substr($this->mailerServerCode($SMTP), 0, 3) != 250) {
            $this->sendMailError($SMTP);
        }

        fputs($SMTP, "AUTH LOGIN\r\n");
        if (substr($this->mailerServerCode($SMTP), 0, 3) != 334) {
            $this->sendMailError($SMTP);
        }

        fputs($SMTP, base64_encode($this->defaultLogin)."\r\n");
        if (substr($this->mailerServerCode($SMTP), 0, 3) != 334) {
            $this->sendMailError($SMTP);
        }

        fputs($SMTP, base64_encode($this->defaultPass)."\r\n");
        if (substr($this->mailerServerCode($SMTP), 0, 3) != 235) {
            $this->sendMailError($SMTP);
        }

        fputs($SMTP, "MAIL FROM:".$this->defaultLogin."\r\n");
        if (substr($this->mailerServerCode($SMTP), 0, 3) != 250) {
            $this->sendMailError($SMTP);
        }

        fputs($SMTP, "RCPT TO:".$this->postWhere."\r\n");
        if (substr($this->mailerServerCode($SMTP), 0, 3) != 250 and $code != 251) {
            $this->sendMailError($SMTP);
        }

        fputs($SMTP, "DATA\r\n");
        if (substr($this->mailerServerCode($SMTP), 0, 3) != 354) {
            $this->sendMailError($SMTP);
        }

        fputs($SMTP, $this->sendMailHeader()."\r\n".$this->postTemplate."\r\n.\r\n");
        if (substr($this->mailerServerCode($SMTP), 0, 3) != 250) {
            $this->sendMailError($SMTP);
        }

        fputs($SMTP, "QUIT\r\n");
        $this->sendMailError($SMTP);

        return true;
    }
}
