<?php  namespace Core\Kernel;

/* Created: HM:Script
*  Website: http://hmscript.net
*     User: ZpVs
*     Date: 03.03.14
*     Time: 15:16
*  Version: 1.5.5
*   Script: hStation CMS
*/
class HmsOauth
{
    public $provider;
    public $authdata = array();
    private $request_url;
    private $token_url;
    private $cliaent_url;
    private $client_id;
    private $secret_key;
    private $scope;
    private $redirect_prefix;
    private $code;

    public function initAuth()
    {
        global $core;
        switch($this->provider) {
            case 'google':
                $g_api = 'https%3A%2F%2Fwww.googleapis.com%2Fauth%2F';
                $this->request_url = 'https://accounts.google.com/o/oauth2/auth?';
                $this->token_url = 'https://accounts.google.com/o/oauth2/token?';
                $this->cliaent_url = 'https://www.googleapis.com/oauth2/v1/userinfo?';
                $this->client_id = $core::$dbs->d_cfg['s_gl_client_id'];
                $this->secret_key = $core::$dbs->d_cfg['s_gl_secret_key'];
                $this->scope = $g_api.'userinfo.email+'.$g_api.'plus.login';
                $this->redirect_prefix = 'auth%26login%26gl_auth';

                break;
            case 'facebook':
                $this->request_url = 'https://graph.facebook.com/oauth/authorize?';
                $this->token_url = 'https://graph.facebook.com/oauth/access_token?';
                $this->cliaent_url = 'https://graph.facebook.com/me?';
                $this->client_id = $core::$dbs->d_cfg['s_fb_client_id'];
                $this->secret_key = $core::$dbs->d_cfg['s_fb_secret_key'];
                $this->scope = 'email';
                $this->redirect_prefix = 'auth%26login%26fb_auth';
                break;
            case 'vkontakte':
                $this->request_url = 'https://oauth.vk.com/authorize?';
                $this->token_url = 'https://oauth.vk.com/access_token?';
                $this->cliaent_url = 'https://api.vk.com/method/users.get?';
                $this->client_id = $core::$dbs->d_cfg['s_vk_client_id'];
                $this->secret_key = $core::$dbs->d_cfg['s_vk_secret_key'];
                $this->scope = 'email';
                $this->redirect_prefix = 'auth%26login%26vk_auth';
                break;
            default:
                if ($core::$engine->query_post) {
                    $user= $_POST['user'];
                    if (!empty($user["email"]) && !empty($user["password"])) {
                        $core::$session->auth($user);
                        __redirect('user&profile');
                    } else {
                        __redirect('auth&login');
                    }
                } else {
                    $core::$template->parts['body']['file'] = 'inc/auth.form.html';
                    $core::$template->tags['title'] = $core::$template->tags['title'].': '._T_AUTH;
                }
        }
    }
    public function getAuthCode()
    {
        global $core;
        if (!empty($this->provider)) {
            $auth_url = $this->request_url
                ."client_id=".$this->client_id
                ."&response_type=code"
                ."&scope=".$this->scope
                ."&redirect_uri=".$core::$dbs->d_cfg['site_url'].'/?'.$this->redirect_prefix;
            header("Location:".$auth_url);
        }
    }
    public function getAuthToken()
    {
        global $core;
        $token = '';
        $request_token = "client_id=".$this->client_id
            ."&client_secret=".$this->secret_key
            ."&grant_type=authorization_code"
            ."&redirect_uri=".$core::$dbs->d_cfg['site_url'].'/?'.$this->redirect_prefix
            ."&code=".$this->code;
        $context = stream_context_create(array(
                'http' => array(
                    'method' => 'POST',
                    'header' => 'Content-Type: application/x-www-form-urlencoded' . PHP_EOL,
                    'content' => $request_token,
                ),
            ));
        $request = file_get_contents($this->token_url, false, $context);
        switch($this->provider){
            case 'facebook':
                $query = explode('&', $request);
                $query = explode('=', $query[0]);
                $token = $query[1];
                break;
            default:
                $query = json_decode($request, true);
                if ($this->provider == 'vkontakte') {
                    $this->authdata['email'] = $query['email'];
                }
                $token = $query["access_token"];
        }
        return $token;

    }
    public function getUserData($token)
    {
        $userdata = '';
        switch($this->provider){
            case 'google':
                $userdata = '';
                break;
            case 'facebook':
                $userdata = 'fields=id,name,email,picture&';
                break;
            case 'vkontakte':
                $userdata = 'fields=uid,email,first_name,last_name,photo_100&';
                break;
            default:
        }
        $request_data = $this->cliaent_url.$userdata."access_token=".$token;
        $social_user = json_decode(file_get_contents($request_data), true);
        switch($this->provider){
            case 'google':
                $this->authdata['email'] = $social_user["email"];
                $this->authdata['name'] = $social_user["name"];
                $this->authdata['avatar'] = $social_user["picture"];
                break;
            case 'facebook':
                $this->authdata['email'] = $social_user["email"];
                $this->authdata['name'] = $social_user["name"];
                $this->authdata['avatar'] = $social_user["picture"]["data"]["url"];
                break;
            case 'vkontakte':
                $response = $social_user["response"][0];
                $this->authdata['name'] = $response["first_name"].' '.$response["last_name"];
                $this->authdata['avatar'] = $response["photo_100"];
                break;
            default:
        }
    }
    public function getAuthData($code)
    {
        if (!empty($this->provider)) {
            $this->code = $code;
            $this->getUserData($this->getAuthToken());

        }
    }
}
