<?php  namespace Core\Kernel;

/**
 * Created by HopsMalt Script.
 * User: 3DHotBoy
 * Date: 24.11.12
 * Time: 2:01
 * HMS Module Engine System
 * Stream Module v1.3 as core v1.1
 */
class HmsPlaylist
{
    private $playlist;
    private $format;
    private $filename;

    public function __construct()
    {

    }

    protected function outPlaylist($data)
    {
        header("HTTP/1.1 200 OK");
        header("Content-Type: application/force-download;");
        header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');
        $ua = (isset($_SERVER['HTTP_USER_AGENT']))?$_SERVER['HTTP_USER_AGENT']:'';
        $IE = preg_match('@MSIE ([0-9].[0-9]{1,2})@', $ua);
        switch ($IE) {
            case $IE:
                header('Content-Disposition: attachment; filename="'.$this->filename.'"');
                header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                header('Pragma: public');

                break;
            default:
                header('Content-Disposition: attachment; filename="'.$this->filename.'"');
                header('Pragma: no-cache');
        }

        return $data;
    }
    protected function getHeader($type)
    {
        global $core;
        $head = '';
        switch ($type) {
            case 'm3u':
                $head .= '#EXTM3U'.PHP_EOL;
                $head .= '#EXTVLCOPT--http-reconnect=true'.PHP_EOL;
                break;
            case 'xspf':
                $head .= '<?xml version="1.0" encoding="UTF-8"?>'.PHP_EOL;
                $head .= '<playlist xmlns:vlc="http://www.videolan.org/vlc/playlist/ns/0/" version="1">'.PHP_EOL;
                $head .= '<title>Плейлист '.$core::$dbs->d_cfg['site_name'].'</title>'.PHP_EOL;
                break;
            case 'mpcpl':
                $head .= 'MPCPLAYLIST'.PHP_EOL;
                break;
            case 'wpl':
                $head .= '<?wpl version="1.0"?>'.PHP_EOL;
                $head .= '<smil>'.PHP_EOL;
                $head .= '<head>'.PHP_EOL;
                $head .= '<meta name="Generator" content="Microsoft Windows Media Player"/>'.PHP_EOL;
                $head .= '<title>'.$core::$dbs->d_cfg['site_name'].'</title>'.PHP_EOL;
                $head .= '</head>'.PHP_EOL;
                $head .= '<body>'.PHP_EOL;
                $head .= '<seq>'.PHP_EOL;
                break;
            case 'xml':
                $head .= '<?xml version="1.0" encoding="UTF-8"?>'.PHP_EOL;
                $head .= '<items>'.PHP_EOL;
                break;
            case 'bouquet':
                $head .= '#NAME StreamSat'.PHP_EOL;
                break;
        }

        return $head;
    }
    protected function getBody($stremtype)
    {
        global $core;
        $channels = $core::$dbs->getAllChannelsFromPlaylist();

        $body = '';
        switch ($this->format) {
            case 'm3u':
                $this->filename = 'streamsat.m3u';
                foreach ($channels as $channel) {
                    $body .= '#EXTINF:-1,'.$channel->getName().PHP_EOL;
                    if ($stremtype == 'http') {
                        if ($core::$session->getState()) {
                            $body .= $channel->getStreamLink('playlist', true).PHP_EOL;
                        } else {
                            $body .= $channel->getStreamLink('', true).PHP_EOL;
                        }

                    } else {
                        $body .= $channel->getTorrentStream().PHP_EOL;
                    }

                }
                break;
            case 'xspf':
                $this->filename = 'streamsat.xspf';
                $body .= '<trackList>'.PHP_EOL;
                foreach ($channels as $channel) {
                    if ($core::$session->getState()) {
                        $stream_link = $channel->getStreamLink('playlist', true);
                    } else {
                        $stream_link = $channel->getStreamLink('', true);
                    }
                    $body .= '<track>'.PHP_EOL;
                    $body .= '<location>'.$stream_link.'</location>'.PHP_EOL;
                    $body .= '<title>'.$channel->getName().'</title>'.PHP_EOL;
                    $body .= '</track>'.PHP_EOL;
                }
                $body .= '</trackList>'.PHP_EOL;
                break;
            case 'mpcpl':
                $this->filename = 'streamsat.mpcpl';
                $count_pl = 1;
                foreach ($channels as $channel) {
                    if ($core::$session->getState()) {
                        $stream_link = $channel->getStreamLink('playlist', true);
                    } else {
                        $stream_link = $channel->getStreamLink('', true);
                    }
                    $body .= $count_pl.',type,0'.PHP_EOL;
                    $body .= $count_pl.',label,'.$channel->getName().PHP_EOL;
                    $body .= $count_pl.',filename,'.$stream_link.PHP_EOL;
                    $count_pl = $count_pl +1;
                }
                break;
            case 'wpl':
                $this->filename = 'streamsat.wpl';
                foreach ($channels as $channel) {
                    if ($core::$session->getState()) {
                        $stream_link = $channel->getStreamLink('playlist', true);
                    } else {
                        $stream_link = $channel->getStreamLink('', true);
                    }
                    $body .= '<media src="'.$stream_link.'/'.$channel->getName().'"/>'.PHP_EOL;
                }
                break;
            case 'xml':
                $this->filename = 'nStream.xml';
                foreach ($channels as $channel) {
                    if ($core::$session->getState()) {
                        $stream_link = $channel->getStreamLink('playlist', true);
                    } else {
                        $stream_link = $channel->getStreamLink('', true);
                    }
                    $body .= '<channel>'.PHP_EOL;
                    $body .= '  	<title>'.$channel->getName().'</title>'.PHP_EOL;
                    $body .= '  	<description>'.$channel->getDescription().'</description>'.PHP_EOL;
                    $body .= '  	<stream_url><![CDATA['.$stream_link.']]></stream_url>'.PHP_EOL;
                    $body .= '</channel>'.PHP_EOL;
                }
                break;
            case 'ext':
                $this->filename = 'streamsat.txt';
                foreach ($channels as $channel) {
                    if ($core::$session->getState()) {
                        $stream_link = $channel->getStreamLink('playlist', true);
                    } else {
                        $stream_link = $channel->getStreamLink('', true);
                    }
                    $body .= 'ext,'.$channel->getName().','.$stream_link.PHP_EOL;
                }
                break;
            case 'bouquet':
                $this->filename = 'userbouquet.iptv.tv';
                $count_pl = 1;
                foreach ($channels as $channel) {
                    if ($core::$session->getState()) {
                        $stream_link = $channel->getStreamLink('playlist', true);
                    } else {
                        $stream_link = $channel->getStreamLink('', true);
                    }
                    $body .= '#SERVICE 4097:0:1:'.$count_pl.':'.urlencode($stream_link).':'.$channel->getName().PHP_EOL;
                    $count_pl = $count_pl +1;
                }
                break;
            case 'feed':
                $this->filename = 'streamsat.feed';
                foreach ($channels as $channel) {
                    if ($core::$session->getState()) {
                        $stream_link = $channel->getStreamLink('playlist', true);
                    } else {
                        $stream_link = $channel->getStreamLink('', true);
                    }
                    $body .= ''.PHP_EOL;
                    $body .= '[TITLE]'.$channel->getName().PHP_EOL;
                    $body .= '[URL]'.$stream_link.PHP_EOL;
                    $body .= '[DESCRIPTION]'.$channel->getDescription().PHP_EOL;
                }
                break;
            case 'json':
                if ($core::$session->getState()) {
                    $stream_link = $channel->getStreamLink('playlist', true);
                } else {
                    $stream_link = $channel->getStreamLink('', true);
                }
                $this->filename = 'streamsat.json';
                $converted = array();
                $count_pl = 1;
                foreach ($channels as $channel) {
                    $converted[$count_pl]['name'] = $channel->getName();
                    $converted[$count_pl]['url'] = $stream_link;
                    $count_pl = $count_pl +1;
                }
                $body .= json_encode($converted);
                break;
        }

        return $body;
    }
    protected function getFooter($type)
    {
        $foot = '';
        switch ($type) {
            case 'xspf':
                $foot .= '</playlist>'.PHP_EOL;
                break;
            case 'wpl':
                $foot .= '</seq>'.PHP_EOL;
                $foot .= '</body>'.PHP_EOL;
                $foot .= '</smil>'.PHP_EOL;
                break;
            case 'xml':
                $foot .= '</items>'.PHP_EOL;
                break;
        }

        return $foot;
    }
    public function getPlaylist($type, $stremtype = 'http')
    {
        $this->format = $type;
        $this->playlist .= $this->getHeader($type).$this->getBody($stremtype).$this->getFooter($type);
        $this->outPlaylist($this->playlist);
        print $this->playlist;
    }
}
