<?php namespace Core\Kernel;

/* Created: HM:Script
*  Website: http://hmscript.net
*     User: ZpVs
*     Date: 23.04.13
*     Time: 16:05
*  Version: 1.0.0
*   Script: hStation CMS
*/
class HmsTemplate
{
    private static $content;
    private static $closed = ___OFFLINE;

    public function __construct($d_cfg)
    {
        foreach ($d_cfg as $settings => $value) {
            $this->$settings = $value;
        }
    }

    /**
     * Разширение стандартных настроек класса
     * шаблона исходя из поступающих данных или запросов.
     */
    public function extendConstruct()
    {
        global $core;
        /**
         * Инициализация  пути базового шаблона для
         * дальнейшего отображения обработанной информации
         */
        if ($this->path == null) {

            if (!empty($_GET) && isset($_GET[$core::$dbs->d_cfg['cp_link']]) && $core::$session->getState()) {
                $user = $core::$dbs->getOneUser();
                if ($user->getRole() > 1) {
                    $this->path = 'core/control/theme';
                } else {
                    $core::$template->path = $core::CONTPATH.'themes/'.$core::$dbs->d_cfg['site_theme'];
                }

            } else {
                $this->path = $core::CONTPATH.'themes/'.$core::$dbs->d_cfg['site_theme'];
            }

        }
        /**
         * Инициализация  файла тела шаблона
         */
        if ($core::$engine->query_get) {
            foreach ($this->baseBody as $body => $page) {
                if ($body == $core::$engine->a_get_index[0]) {
                    $this->parts['body']['file'] = $page;
                }
            }
        }

        /**
         * Инициализация базовых тегов замены
         */
        $this->tags['url'] = $core::$dbs->d_cfg['site_url'];
        $this->tags['theme'] = $core::$dbs->d_cfg['site_url'].'/'.$this->path;
        $this->tags['title'] = $core::$dbs->d_cfg['site_name'];
        $this->tags['description'] = $core::$dbs->d_cfg['site_description'];
        $this->tags['keywords'] = $core::$dbs->d_cfg['site_keywords'];
    }
    /**
     * Функция замены  переменных в шаблоне по заданным правилам.
     * @variable := string - название переменной в шаблоне.
     * @value := string  - на что заменять переменную
     * @ext_template  - шаблон в котором производить замену
     **/
    public function __rT($variable, $value, $ext_template)
    {
        $ext_variable = "{:".$variable.":}";
        if ($value) {
            return str_replace($ext_variable, $value, $ext_template);
        } else {
            return str_replace($ext_variable, '', $ext_template);
        }
    }

    /**
     * Инициализация основных частей ХТМЛ шаблона
     * @param $elements - части шаблона которые необходимо
     * загрузить для обработки  ( string или array())
     * @return string - Собраные части шаблона в
     *                статической переменной класса
     */
    public function tplData($elements)
    {
        $i_tpl = explode(':', $elements);
        $tpl = '';
        foreach ($i_tpl as $tpl_element) {
            if (!empty($tpl_element) && $this->parts[$tpl_element]['visible']) {
                $tpl .= file_get_contents($this->path.'/'.$this->parts[$tpl_element]['file']);
            }
        }
        self::$content = $tpl;
    }

    /**
     * Генерация списка заменяемых тегов в шаблоне для
     * дальнейшего использования при инициализации шаблона
     */
    public function listTags()
    {
        foreach ($this->tags as $tags => $tagInner) {
            $this->tagList[] = "{:".$tags.":}";
        }
    }

    /**
     * Замена производимая в статическом контенте
     * определенными тегами замены
     */
    public function themeRewrite()
    {
        foreach ($this->tags as $tag => $tagInner) {
            self::$content = $this->__rT($tag, $tagInner, self::$content);
        }
    }
    public function themeRewriteCode()
    {
        preg_match_all('#{code:(.+?):code}#is', self::$content, $codes);
        foreach ($codes[1] as $code) {
            ob_start();
            eval($code);
            $result = ob_get_contents();
            ob_end_clean();
            self::$content = str_replace('{code:'.$code.':code}', $result, self::$content);
        }
    }
    public function themeRewriteTxt()
    {
        preg_match_all('#{txt:(.+?):}#is', self::$content, $txt);
        foreach ($txt[1] as $text) {
            $text_lang = constant(strtoupper($text));
            if (isset($text_lang)) {
                self::$content = str_replace('{txt:'.$text.':}', $text_lang, self::$content);
            }
        }
    }

    public function compress($code)
    {
        $code = preg_replace('/\/\*(?!-)[\x00-\xff]*?\*\//', '', $code);
        $code = preg_replace('/\\/\\*[^*]*\\*+([^\\/][^*]*\\*+)*\\//', '', $code);
        $code = preg_replace('/\s\s+/', ' ', $code);

         return preg_replace('/\s?([\{\};\=\(\)\/\+\*-])\s?/', "\\1", $code);
    }
    /**
     * Инициализация всех необходимых функций и
     * переменных для окончательной обработки  и вывода шаблона
     */
    public function initTheme()
    {
        global $core;
        $this->listTags();
        $this->tplData('header:body:footer');
        foreach ($this->tagList as $tag) {
            while (strpos(self::$content, $tag)) {
                $this->themeRewrite();
            }
        }
        $this->themeRewriteCode();
        $this->themeRewriteTxt();

        if ($core::$dbs->d_cfg["state"] == 1 || $core::$user->getRole() > 1) {
            if ($core::$dbs->d_cfg["compress"] == 1) {
                print $this->compress(self::$content);
            } else {
                print self::$content;
            }

        } else {
            print self::$closed;
        }
    }
}
