<?php namespace Core\Kernel;

/* Created: HM:Script
*  Website: http://hmscript.net
*     User: ZpVs
*     Date: 23.04.13
*     Time: 16:05
*  Version: 1.0.0
*   Script: hStation CMS
*/
class HmsUser
{
    private $id = null;
    private $email = null;
    private $phone = null;
    private $unique_k = null;
    private $i_key = null;
    private $lastip = null;
    private $role = null;
    private $role_name = null;

    public function __construct($id, $email, $phone, $unique_k, $i_key, $lastip)
    {
        $this->id = $id;
        $this->email = $email;
        $this->phone = $phone;
        $this->unique_k = $unique_k;
        $this->i_key = $i_key;
        $this->lastip = $lastip;
    }
    public function __us()
    {
        global $core;

        return $core::$session->state;
    }

    public function __userdata($param)
    {
        global $core;

        return $core::$dbs->getUserInfo($param, $this->i_key);
    }
    /** Роль пользователя*/
    public function spotUserRole()
    {
        global $core;
        $role = $core::$dbs->getUserRole($this->i_key);
        $this->role = $role[0];
        $this->role_name = $role[1];
    }
    public function getRole()
    {
        if ($this->role == null) {
            $this->spotUserRole();
        }

        return $this->role;
    }
    public function getRoleName()
    {
        if ($this->role_name == null) {
            $this->spotUserRole();
        }

        return $this->role_name;
    }
    /** Базовые данные пользователя*/
    public function getIkey()
    {
        return $this->i_key;
    }
    public function getId()
    {
        return $this->id;
    }
    public function getEmail()
    {
        return $this->email;
    }
    public function getPhone()
    {
        return $this->phone;
    }
    public function getUserKey()
    {
        return $this->unique_k;
    }
    public function getLastip()
    {
        return $this->lastip;
    }
    public function getAvatar()
    {
        global $core;
        $rand = mt_rand(000000000, 999999999);
        return $core::$dbs->d_cfg['site_url'].'/content/uploads/images/'.md5($this->email).'.png?v='.$rand;
    }
    public function getUsername()
    {

            return  $this->__userdata('username');

    }
    public function getNavigations()
    {
        global $core;
        $theme = $core::$dbs->d_cfg['site_theme'];
        if ($this->__us()) {
            $uNav = file_get_contents($core::CONTPATH.'themes/'.$theme.'/inc/user.nav.html');
        } else {
            $uNav = file_get_contents($core::CONTPATH.'themes/'.$theme.'/inc/no_user.nav.html');
        }
        $uNav = $core::$template->__rT('url', $core::$dbs->d_cfg['site_url'], $uNav);

        return  $uNav;

    }
    public function getWebsite()
    {
        $data = $this->__userdata('website');

        return  !empty($data)?$data: ___NO_DATA;
    }
    public function getLocation()
    {
        $data = $this->__userdata('location');

        return  !empty($data)?$data: ___NO_DATA;
    }
    public function getContact()
    {
        $data = $this->__userdata('contacts');

        return  !empty($data)?$data: ___NO_DATA;
    }
    public function getAbout()
    {
        $data = $this->__userdata('about');

        return  !empty($data)?$data: ___NO_DATA;
    }
    public function getJoined()
    {
        $data = $this->__userdata('joined');

        return  !empty($data)?$data: '';
    }
    public function getMessegeState()
    {
        $data = $this->__userdata('up_changes');

        return  ($data == 1)?'checked':'';
    }
    public function getNewsMessegeState()
    {
        $data = $this->__userdata('up_news');

        return  ($data == 1)?'checked':'';
    }
    public function getRemoteControlState()
    {
        $data = $this->__userdata('remote_control');

        return  ($data == 1)?'checked':'';
    }
    public function getLargeScreenState()
    {
        $data = $this->__userdata('large_screen');

        return  ($data == 1)?'checked':'';
    }
    public function getAutoplayState()
    {
        $data = $this->__userdata('autoplay');

        return  ($data == 1)?'checked':'';
    }
    public function getTorrentplayState()
    {
        $data = $this->__userdata('torrentplay');

        return  ($data == 1)?'checked':'';
    }
    public function getBalance()
    {
        global $core;

        return $core::$dbs->getUserBalance($this->i_key);
    }
    public function getTransactions()
    {
        global $core;

        return $core::$dbs->getUserTransactions($this->i_key);
    }
    public function getUserSubscribe()
    {
        global $core;

        return $core::$dbs->getUserSubscribe($this->i_key);
    }
    public function getUserPultCommand()
    {
        global $core;
        $command = $core::$dbs->getPultCommand($this->i_key);
        $this->addUserPultCommand('');

        return $command;
    }

    public function addUserPultCommand($command)
    {
        global $core;

        return $core::$dbs->addPultCommand($this->i_key, $command);
    }
    public function addUserPayInfo($post)
    {
        global $core;
        $post['i_key'] = $this->i_key;
        $post['date'] = date('Y-m-d');

        return $core::$dbs->addUserPay($post);
    }
    public function addUserSubscribe($coast)
    {
        global $core;
        switch ($coast) {
            case '3':
                $data['date']= date('Y-m-d', mktime(0, 0, 0, date("m")+1, date("d"), date("Y")));
                break;
            case '7.5':
                $data['date']= date('Y-m-d', mktime(0, 0, 0, date("m")+3, date("d"), date("Y")));
                break;
            case '15':
                $data['date']= date('Y-m-d', mktime(0, 0, 0, date("m")+6, date("d"), date("Y")));
                break;
            case '26':
                $data['date']= date('Y-m-d', mktime(0, 0, 0, date("m"), date("d"), date("Y")+1));
                break;
        }
        $data['new_balance'] = $this->getBalance() - $coast;
        $data['i_key'] = $this->i_key;
        $data['pamount'] = $coast;
        $data['pid'] = __pay_unikey();

        return $core::$dbs->addUserSubcribe($data);
    }
    public function addUserBalanceFromVoucher($voucher)
    {
        global $core;

        return $core::$dbs->addUserBalance($this->i_key, $voucher);
    }
    public function addUserBalanceFromPay($pay_key)
    {
        global $core;

        return $core::$dbs->addUserBalanceFromPay($this->i_key, $pay_key);
    }
    public function changeSubscribeState()
    {
        global $core;

        return $core::$dbs->editSubscribeState($this->i_key);
    }
    public function changeTvSettings($settings)
    {
        global $core;
        if (isset($settings['user'])) {
            return $core::$dbs->editTvSettings($this->i_key, $settings['user'], '1');
        } else {
            return $core::$dbs->editTvSettings($this->i_key, $settings['clear'], '0');
        }

    }
    public function setName($name)
    {
        global $core;
        $core::$dbs->setUserName($this->i_key, $name);
    }
}
